$lib "MMC.LIB"
$external _mmc
$regfile = "m32def.dat"
$baud = 19200
$crystal = 11059200
$hwstack = 64
$swstack = 20
$framesize = 80


Config Portd.5 = Output
Cts Alias Portd.5

Config Pinc.0 = Input

'GPS-Maus angeschlossen
Config Pinb.3 = Input
Cmd5 Alias Pinb.3

'Mobiltelefon angeschlossen
Config Pina.2 = Input
Cmd2 Alias Pina.2

'Serieller_adapter angeschlossen
Config Pina.1 = Input
Cmd4 Alias Pina.1

Config Portd.4 = Output
Rts Alias Portd.4

Config Porta.3 = Output
Mob_ein Alias Porta.3

Config Porta.1 = Output
Mob_opto Alias Porta.1

Config Serialin = Buffered , Size = 254
Enable Interrupts

Config Porta.0 = Output
Led Alias Porta.0

Config Pinb.4 = Output
Mmc_cs Alias Portb.4
Set Mmc_cs
Config Pinb.4 = Output
Spi_ss Alias Portb.4
Set Spi_ss
Config Spi = Hard , Interrupt = Off , Data Order = Msb , Master = Yes , Polarity = High , Phase = 1 , Clockrate = 4 , Noss = 1
Spiinit

Config Timer0 = Timer , Prescale = 1024
On Ovf0 Tim0_isr
Enable Timer0

Declare Sub Master_toc_bearbeiten()
Declare Sub Master_toc_anlegen()
Declare Sub Long_speichern(byval Longvariable As Long , Positionszahler_speicher As Word)
Declare Sub Long_lesen(positionszahler_speicher As Word)
Declare Sub Single_speichern(byval Singlevariable As Single , Positionszahler_speicher As Word)
Declare Sub Single_lesen(positionszahler_speicher As Word)
Declare Sub Speicherinhalt_leeren()
Declare Sub Master_toc_auslesen()
Declare Sub Master_toc_darstellen()
Declare Sub Sd_karte_schreiben(sektornummer As Long)
Declare Sub Sd_karte_lesen(sektornummer As Long)
Declare Sub Toc_eintrag_hinzufuegen()
Declare Sub Toc_auslesen(toc_nummer As Long)
Declare Sub Toc_darstellen(toc_nummer As Long)

Declare Sub Aufnahme_machen()
Declare Sub Displayanzeige()
Declare Sub Guthaben_aufladen()
Declare Sub Datenverbindung_aufbauen()
Declare Sub Sprachverbindung_aufbauen()
Declare Sub Wortsucher()
Declare Sub Sms_senden()
Declare Sub Kameraein()
Declare Sub Mobilein()

Declare Sub Eing_v_uart()
Declare Sub Bildausgabe()

Declare Sub Gps_auslesen()

'Variablen, die fuer die Master_Toc reserviert sind
Dim Datentraegerbezeichnung As String * 16
Dim Datentraegergroesse As Long
Dim Belegter_speicher As Long
Dim Anzahl_eintraege As Long
Dim Anzahl_ordner As Long
Dim Beginn_der_toc As Long
Dim Ende_der_toc As Long

'Variablen, die fuer die TOC reserviert sind
Dim Ordnername As String * 16
Dim Dateiname As String * 16
Dim Datum_tag As Byte
Dim Datum_monat As Byte
Dim Datum_jahr As Byte
Dim Uhr_stunde As Byte
Dim Uhr_minute As Byte
Dim Uhr_sekunde As Byte
Dim Uhr_stunde_master As Byte
Dim Uhr_minute_master As Byte
Dim Uhr_sekunde_master As Byte
Dim Position_nord As Single
Dim Position_ost As Single
Dim Position_hoehe As Single
Dim Dateianfang_sektor As Long
Dim Dateiende_sektor As Long
Dim Dateiende_segment As Long
Dim Toc_nummer As Long
Dim Segment_start As Long

Dim Spezialzaehler As Integer
Dim Laenge As Byte
Dim Zahler As Byte
Dim Positionszahler_speicher As Word
Dim Zahler_loeschen As Word
Dim Speicherinhalt(512) As Byte
Dim Text_1 As String * 1

Dim Longvariable As Long
Dim L1 As Byte
Dim L2 As Byte
Dim L3 As Byte
Dim L4 As Byte
Dim Lbyte_long(4) As Byte
Dim Long_wert As Long At Lbyte_long Overlay

Dim Singlevariable As Single
Dim S1 As Byte
Dim S2 As Byte
Dim S3 As Byte
Dim S4 As Byte
Dim Sbyte_single(4) As Byte
Dim Single_wert As Single At Sbyte_single Overlay


Dim Wsrampointer As Word
Wsrampointer = Varptr(speicherinhalt(1))
Dim Sektornummer As Long

Dim Zwischenspeicher_int As Integer
Dim Zwischenspeicher_single As Single
Dim Zwischenspeicher2_int As Integer
Dim Zwischenspeicher2_single As Single
Dim Zwischenspeicher_long As Long


Const Cperrdrivereset = 100
Const Cperrdriveinit = 101
Const Cperrdrivereadcommand = 102
Const Cperrdrivewritecommand = 103
Const Cperrdrivereadresponse = 104
Const Cperrdrivewriteresponse = 105
Const Cperrdrive = 106
Waitms 1
Dim Gbdriveerror As Byte
Dim Gbdriveerrorreg As Byte
Dim Gbdrivestatusreg As Byte
Dim Gbdrivedebug As Byte

Dim Dat As Byte
Dim Eingabechar As Byte
Dim Eingabechar2 As Byte
Dim Eingabechar3 As Byte
'Dim Zahler As Integer

Dim Abbruch As Long
Dim Ausgeben As Byte
Dim Aufnahme_machen As Byte

Dim Ausgabeformat As Byte
'Ausgabeformat
'1=Zeichen 8Bit
'2=Hex
Dim Nur_datenausgeben As Byte
Dim Datenfreigabe_01 As Byte
Dim Datenfreigabe_02 As Byte
Dim Datenfreigabe As Byte

Dim Eepromspeicherung As Byte
Dim Blitzlicht As Byte
Dim Grosses_bild As Byte
Dim Kompress_qualitaet As Byte

Dim Netzanbieter As Byte
'1 Aldi-Talk (eplus) --> Guthabenstand per *100# und Auflademglichkeit
'2 Tchibo (o2)--> Guthabenstand per *101# keine Online-Auflademglichkeit
Dim Guthaben As Eram String * 100
Dim Ringwort As String * 30
Dim Msg As String * 100
Dim Msg_02 As String * 200
Dim Zwischenergebnis As String * 2
Dim T1 As String * 1
Dim Kameratext As String * 30
Dim Zwischenspeicher1 As String * 20
Dim Zwischenspeicher2 As String * 20
Dim Telefonnummer As String * 15
Dim T1_d As String * 2
Dim T2 As String * 2
Dim T3 As String * 1
Dim I1 As Byte
Dim Msglen As Byte
Dim Zwischenwert_s As Single
Dim Zwischenwert_b As Byte
Dim Hexanzahl As Byte
'Dim Laenge As Byte

Dim Ringwortzahler As Byte
Dim Wortenthalten As Byte
Dim I2 As Byte
Dim I3 As Byte
Dim K1 As Byte
Dim K2 As Byte
Dim K3 As Byte

Dim Zw_hex As Byte
Dim Nachrichtenlaenge As Integer
Dim Smsversuchszahler As Byte


Dim Im_sektorzaehler As Word
Dim Sektorzaehler As Word
Dim Pausensektorzahler As Byte
dim pausensektorvorgabe as byte
dim Uebertragungsunterbrechungszeit as integer
Dim Im_sektorzaehler_a As Word
Dim Sektorzaehler_a As Word
Dim Pufferspeicher(30) As Byte
Dim Pufferzahler As Byte
Dim Dauerbildaufnahme_zahler As Byte
Dim Dauerbildaufnahme_wert As Byte

Dim Komma As Byte
Dim Uhrzeit_stunde As Byte
Dim Uhrzeit_minute As Byte
Dim Uhrzeit_sekunde As Byte
Dim Uhrzeitstring As String * 10
Dim Nordkoordinate As Single
Dim Nordkoordinate_i As Integer
Dim Ostkoordinate As Single
Dim Ostkoordinate_i As Integer
Dim Genauigkeit As Single
Dim Hoehe As Integer
Dim Wartezeit As Integer
Dim Ausleseversuche As Byte
Dim Timeout_gps As Long
Dim Timeoutzahler As Long
Dim Mobil_ist_aktiv As Boolean
Dim Bildprozedur As Bit
Dim Timerzaehler As Integer
Dim Timerzaehler_uhr As Integer
Dim Textausgabewert As Byte

Uhr_stunde_master = 00
Uhr_minute_master = 00
Uhr_sekunde_master = 00

Mob_ein = 1
Ausgabeformat = 2
Grosses_bild = 0
Eepromspeicherung = 1
Blitzlicht = 0
Nur_datenausgeben = 0
Kompress_qualitaet = 2
Netzanbieter = 2
Uebertragungsunterbrechungszeit = 2000
Pausensektorvorgabe = 10

Open "coma.6:9600,8,n,1" For Output As #1
Open "coma.5:9600,8,n,1" For Input As #2
Open "comc.0:4800,8,n,1" For Input As #3
Open "comc.1:4800,8,n,1" For Output As #4

'Ab hier BOOTSEQUENZ

Waitms 1000

Print #4 , "Programm gestartet."

Print #1 , "Programm gestartet"
Print #1 , ""

Print #4 , "Mobiltelefon wird gestartet."
Call Mobilein()
Waitms 2000
Print #4 , "Mobiltelefon wurde gestartet."


Sektornummer = 1
Call Sd_karte_lesen(sektornummer)
Call Master_toc_darstellen()

Sektornummer = 1
Call Sd_karte_lesen(sektornummer)
Call Master_toc_auslesen()

If Datentraegergroesse > 0 Then
'Master-TOC vorhanden --> nichts weiter unternehmen
nop
Else
'Anfang Anlegen der Master-TOC
Call Master_toc_anlegen()
Ordnername = "INIT"
Dateiname = "Initialisierung"
Datum_tag = 07
Datum_monat = 3
Datum_jahr = 10
Uhr_stunde = Uhr_stunde_master
Uhr_minute = Uhr_minute_master
Uhr_sekunde = Uhr_sekunde_master
Position_nord = 9.9999
Position_ost = 9.9999
Position_hoehe = 999
Dateianfang_sektor = 10000
Dateiende_sektor = 10001
Dateiende_segment = 99
Call Toc_eintrag_hinzufuegen()
Sektornummer = 1
Call Sd_karte_lesen(sektornummer)
Call Master_toc_darstellen()
'Ende Anlegen der Master-TOC
End If

Porta.2 = 1
Porta.1 = 1

Waitms 200
If Cmd2 = 0 Then
Msg = "BOOT-Info:" + Chr(13)
Msg = Msg + Datentraegerbezeichnung
Msg = Msg + Chr(13)
Msg = Msg + "Anz. Dateien: "
Msg = Msg + Str(anzahl_eintraege)
Msg = Msg + Chr(13)
Msg = Msg + "Belegt(Byte): "
Msg = Msg + Chr(13)
Msg = Msg + Str(belegter_speicher)
Msg = Msg + " "
Print #1 , "AT"
Waitms 500
Call Displayanzeige()
Waitms 8000
Print #1 , "AT"
End If
'ENDE der BOOTSEQUENZ

Do
Porta.1 = 1
Porta.2 = 1
Waitms 20
If Cmd4 = 1 And Cmd2 = 1 Then

Grosses_bild = 1
Kompress_qualitaet = 1
Print #1 , "Bildmodus wird geladen"
Led = 0
Wortenthalten = 1
'Setzen der Steuerleitungen fr die Kamera
Cts = 0
Rts = 0
Led = 0
Baud = 19200
Clear Serialin
Call Aufnahme_machen()
Wait 3

Else
Call Wortsucher()
End If

Loop

End

Sub Master_toc_bearbeiten()
'Abspeichern des Datentraegernamens
'Print "Datentraeger_name (soll): " ; Datentraegerbezeichnung
Laenge = Len(datentraegerbezeichnung)
'Print "Laenge der Bezeichnung: " ; Laenge
Zahler = 1
'Gibt die Speicherzelle im Segment an
Positionszahler_speicher = 1
While Zahler <= Laenge
Text_1 = Mid(datentraegerbezeichnung , Zahler , 1)
Speicherinhalt(positionszahler_speicher) = Asc(text_1)
'Print Speicherinhalt(positionszahler_speicher)
Incr Positionszahler_speicher
Incr Zahler
Wend

'Definierte Laenge der Bezeichnung von 16 Zeichen
Positionszahler_speicher = 17
'Abspeichern der Datentrgergroesse
Longvariable = Datentraegergroesse
Call Long_speichern(longvariable , Positionszahler_speicher )

'Abspeichern des Belegten_Speichers
Longvariable = Belegter_speicher
Call Long_speichern(longvariable , Positionszahler_speicher )

'Abspeichern Anzahl der Eintraege
Longvariable = Anzahl_eintraege
Call Long_speichern(longvariable , Positionszahler_speicher )

'Abspeichern der Anzahl der Ordner
Longvariable = Anzahl_ordner
Call Long_speichern(longvariable , Positionszahler_speicher )

'Abspeichern des Beginn_der_toc
Longvariable = Beginn_der_toc
Call Long_speichern(longvariable , Positionszahler_speicher )

'Abspeichern des Ende_der_toc
Longvariable = Ende_der_toc
Call Long_speichern(longvariable , Positionszahler_speicher )

End Sub

Sub Long_speichern(byval Longvariable As Long , Positionszahler_speicher As Word)

Long_wert = Longvariable
L1 = Lbyte_long(1)
L2 = Lbyte_long(2)
L3 = Lbyte_long(3)
L4 = Lbyte_long(4)

Speicherinhalt(positionszahler_speicher) = L1
Incr Positionszahler_speicher
Speicherinhalt(positionszahler_speicher) = L2
Incr Positionszahler_speicher
Speicherinhalt(positionszahler_speicher) = L3
Incr Positionszahler_speicher
Speicherinhalt(positionszahler_speicher) = L4
Incr Positionszahler_speicher
End Sub

Sub Single_speichern(byval Singlevariable As Long , Positionszahler_speicher As Word)

Single_wert = Singlevariable
S1 = Sbyte_single(1)
S2 = Sbyte_single(2)
S3 = Sbyte_single(3)
S4 = Sbyte_single(4)

Speicherinhalt(positionszahler_speicher) = S1
Incr Positionszahler_speicher
Speicherinhalt(positionszahler_speicher) = S2
Incr Positionszahler_speicher
Speicherinhalt(positionszahler_speicher) = S3
Incr Positionszahler_speicher
Speicherinhalt(positionszahler_speicher) = S4
Incr Positionszahler_speicher
End Sub


Sub Speicherinhalt_leeren()
Zahler_loeschen = 1
While Zahler_loeschen < 512
Speicherinhalt(zahler_loeschen) = 0
Incr Zahler_loeschen
Wend
End Sub

Sub Master_toc_anlegen()
Datentraegerbezeichnung = "GPS BILD Logger"
Datentraegergroesse = 1953125000
Belegter_speicher = 0
Anzahl_eintraege = 0
Anzahl_ordner = 0
Beginn_der_toc = 2
Ende_der_toc = 9999
Call Speicherinhalt_leeren()
Call Master_toc_bearbeiten()
Sektornummer = 1
Call Sd_karte_schreiben(sektornummer)
Call Speicherinhalt_leeren()
End Sub


Sub Master_toc_auslesen()

Datentraegerbezeichnung = ""
Positionszahler_speicher = 1
While Positionszahler_speicher <= 16
If Speicherinhalt(positionszahler_speicher) > 0 Then
Datentraegerbezeichnung = Datentraegerbezeichnung + Chr(speicherinhalt(positionszahler_speicher))
End If
Incr Positionszahler_speicher
Wend

'Datentraegergroesse
Positionszahler_speicher = 17
Call Long_lesen(positionszahler_speicher)
Datentraegergroesse = Long_wert

'Belegter_speicher
Call Long_lesen(positionszahler_speicher)
Belegter_speicher = Long_wert

'Anzahl_eintraege
Call Long_lesen(positionszahler_speicher)
Anzahl_eintraege = Long_wert

'Anzahl_ordner
Call Long_lesen(positionszahler_speicher)
Anzahl_ordner = Long_wert

'Beginn_der_toc
Call Long_lesen(positionszahler_speicher)
Beginn_der_toc = Long_wert

'Ende_der_toc
Call Long_lesen(positionszahler_speicher)
Ende_der_toc = Long_wert

End Sub

Sub Long_lesen(positionszahler_speicher As Word)

Lbyte_long(1) = Speicherinhalt(positionszahler_speicher)
Incr Positionszahler_speicher

Lbyte_long(2) = Speicherinhalt(positionszahler_speicher)
Incr Positionszahler_speicher

Lbyte_long(3) = Speicherinhalt(positionszahler_speicher)
Incr Positionszahler_speicher

Lbyte_long(4) = Speicherinhalt(positionszahler_speicher)
Incr Positionszahler_speicher

End Sub


Sub Single_lesen(positionszahler_speicher As Word)

Sbyte_single(1) = Speicherinhalt(positionszahler_speicher)
Incr Positionszahler_speicher

Sbyte_single(2) = Speicherinhalt(positionszahler_speicher)
Incr Positionszahler_speicher

Sbyte_single(3) = Speicherinhalt(positionszahler_speicher)
Incr Positionszahler_speicher

Sbyte_single(4) = Speicherinhalt(positionszahler_speicher)
Incr Positionszahler_speicher

End Sub


Sub Master_toc_darstellen()
Call Master_toc_auslesen()
Print #1 , "MASTER-TOC"
Print #1 , "----------"
Print #1 , ""
Print #1 , "Datentraegerbezeichnung: " ; Datentraegerbezeichnung
Print #1 , "Groesse in Byte: " ; Datentraegergroesse
Print #1 , "Belegt in Byte: " ; Belegter_speicher
Print #1 , "Anzahl Dateien: " ; Anzahl_eintraege
Print #1 , "Anzahl Ordner: " ; Anzahl_ordner
Print #1 , "Beginn der TOC: " ; Beginn_der_toc
Print #1 , "Ende der TOC: " ; Ende_der_toc
Print #1 , ""
Print #1 , "----------"

End Sub

Sub Sd_karte_schreiben(sektornummer As Long)
Gbdriveerror = Driveinit()
If Gbdriveerror > 0 Then
Print #1 , "Achtung! SD-Karte kann nicht initialisiert werden: " ; Gbdriveerror
End If

Gbdriveerror = Drivewritesector(wsrampointer , Sektornummer )
If Gbdriveerror > 0 Then
Print #1 , "Achtung! Auf SD-Karte kann nicht geschrieben werden: " ; Gbdriveerror
End If
End Sub


Sub Sd_karte_lesen(sektornummer As Long)
Gbdriveerror = Driveinit()
If Gbdriveerror > 0 Then
Print #1 , "Achtung! SD-Karte kann nicht initialisiert werden: " ; Gbdriveerror
End If

Gbdriveerror = Drivereadsector(wsrampointer , Sektornummer )
If Gbdriveerror > 0 Then
Print #1 , "Achtung! Von SD-Karte kann nicht gelesen werden: " ; Gbdriveerror
End If

End Sub

Sub Toc_eintrag_hinzufuegen()
Call Speicherinhalt_leeren()
'Ermitteln des letzten TOC-Eintrags
Sektornummer = 1
Call Sd_karte_lesen(sektornummer)
Call Master_toc_auslesen()
If Anzahl_eintraege > 0 Then
'Beispiel: Anzahl_eintraege = 123 --> 15/3 absolut bzw. 15/3*64 Byte
Zwischenspeicher_int = Anzahl_eintraege / 8
Zwischenspeicher_single = Anzahl_eintraege / 8


'da Eintrag No 1 die Master-TOC ist, wird 2 addiert
Sektornummer = Zwischenspeicher_int + 2

Zwischenspeicher_single = Zwischenspeicher_single - Zwischenspeicher_int
Zwischenspeicher_int = Zwischenspeicher_single * 8
Positionszahler_speicher = Zwischenspeicher_int

'Da 8 Eintraege pro Sektor, die jeweils 64 Byte umfassen
Positionszahler_speicher = Positionszahler_speicher * 64
Else
Sektornummer = 2
Positionszahler_speicher = 0
End If

If Positionszahler_speicher = 0 Then
Positionszahler_speicher = 1
End If

'Print #1 , "SCHREIBEN - Sektor: " ; Sektornummer
'Print #1 , "SCHREIBEN - : Positionszahler_speicher" ; Positionszahler_speicher

'Alle 8 Eintraege in den Speicher laden
Call Sd_karte_lesen(sektornummer)

Zwischenspeicher_int = Positionszahler_speicher
'Hinzufuegen des Ordnernamens
Laenge = Len(ordnername)
Zahler = 1
While Zahler <= Laenge
Text_1 = Mid(ordnername , Zahler , 1)
Speicherinhalt(positionszahler_speicher) = Asc(text_1)
Incr Positionszahler_speicher
Incr Zahler
Wend

While Zahler <= 16
Speicherinhalt(positionszahler_speicher) = 0
Incr Positionszahler_speicher
Incr Zahler
Wend

Positionszahler_speicher = Zwischenspeicher_int + 16

Zwischenspeicher_int = Positionszahler_speicher
'Hinzufuegen des Dateinamens
Laenge = Len(dateiname)
Zahler = 1
While Zahler <= Laenge
Text_1 = Mid(dateiname , Zahler , 1)
Speicherinhalt(positionszahler_speicher) = Asc(text_1)
Incr Positionszahler_speicher
Incr Zahler
Wend

While Zahler <= 16
Speicherinhalt(positionszahler_speicher) = 0
Incr Positionszahler_speicher
Incr Zahler
Wend

Positionszahler_speicher = Zwischenspeicher_int + 16

'Hinzufuegen des Datums
Speicherinhalt(positionszahler_speicher) = Datum_tag
Incr Positionszahler_speicher
Speicherinhalt(positionszahler_speicher) = Datum_monat
Incr Positionszahler_speicher
Speicherinhalt(positionszahler_speicher) = Datum_jahr
Incr Positionszahler_speicher

'Hinzufuegen der Uhrzeit
Speicherinhalt(positionszahler_speicher) = Uhr_stunde
Incr Positionszahler_speicher
Speicherinhalt(positionszahler_speicher) = Uhr_minute
Incr Positionszahler_speicher
Speicherinhalt(positionszahler_speicher) = Uhr_sekunde
Incr Positionszahler_speicher

'Hinzufgen der Position
Singlevariable = Position_nord
Call Single_speichern(singlevariable , Positionszahler_speicher )
Singlevariable = Position_ost
Call Single_speichern(singlevariable , Positionszahler_speicher )
Singlevariable = Position_hoehe
Call Single_speichern(singlevariable , Positionszahler_speicher )

'Abspeichern der Dateidimensionen
Longvariable = Dateianfang_sektor
Call Long_speichern(longvariable , Positionszahler_speicher )
Longvariable = Dateiende_sektor
Call Long_speichern(longvariable , Positionszahler_speicher )
Longvariable = Dateiende_segment
Call Long_speichern(longvariable , Positionszahler_speicher )

Call Sd_karte_schreiben(sektornummer)

'Aktualisieren der Master-TOC
Sektornummer = 1
Call Sd_karte_lesen(sektornummer)
Call Master_toc_auslesen()
Zwischenspeicher_long = Dateiende_sektor - Dateianfang_sektor
Zwischenspeicher_long = Zwischenspeicher_long * 512
Zwischenspeicher_long = Zwischenspeicher_long + Dateiende_segment
Belegter_speicher = Belegter_speicher + Zwischenspeicher_long
Anzahl_eintraege = Anzahl_eintraege + 1
Anzahl_ordner = 0
Beginn_der_toc = 2
Ende_der_toc = 9999
Call Speicherinhalt_leeren()
Call Master_toc_bearbeiten()
Sektornummer = 1
Call Sd_karte_schreiben(sektornummer)
Call Speicherinhalt_leeren()

End Sub

Sub Toc_auslesen(toc_nummer As Long)
Call Speicherinhalt_leeren()
'Ermitteln des letzten TOC-Eintrags
Sektornummer = 1
Call Sd_karte_lesen(sektornummer)
Call Master_toc_auslesen()

'Beispiel: Anzahl_eintraege = 123 --> 15/3 absolut bzw. 15/3*64 Byte
Zwischenspeicher_int = Toc_nummer / 8
'da Eintrag No 1 die Master-TOC ist, wird 2 addiert
Sektornummer = Zwischenspeicher_int + 2
Zwischenspeicher_single = Toc_nummer / 8
Zwischenspeicher_single = Zwischenspeicher_single - Zwischenspeicher_int
Zwischenspeicher_int = Zwischenspeicher_single * 8
Positionszahler_speicher = Zwischenspeicher_int

If Positionszahler_speicher = 0 Then
Positionszahler_speicher = 8
Sektornummer = Sektornummer - 1
End If
'Da 8 Eintraege pro Sektor, die jeweils 64 Byte umfassen
Positionszahler_speicher = Positionszahler_speicher * 64
Positionszahler_speicher = Positionszahler_speicher - 64

If Positionszahler_speicher = 0 Then
Positionszahler_speicher = 1
End If
'Alle 8 Eintraege des interessierenden Sektors in den Speicher laden
'Print #1 , "Lesen - Sektor: " ; Sektornummer
'Print #1 , "Lesen - : Positionszahler_speicher" ; Positionszahler_speicher

Call Sd_karte_lesen(sektornummer)

'alle Elemente auslesen
Ordnername = ""
Zahler = 1
While Zahler <= 16
If Speicherinhalt(positionszahler_speicher) > 0 Then
Ordnername = Ordnername + Chr(speicherinhalt(positionszahler_speicher))
End If
Incr Positionszahler_speicher
Incr Zahler
Wend

Dateiname = ""
Zahler = 1
While Zahler <= 16
If Speicherinhalt(positionszahler_speicher) > 0 Then
Dateiname = Dateiname + Chr(speicherinhalt(positionszahler_speicher))
End If
Incr Positionszahler_speicher
Incr Zahler
Wend

Datum_tag = Speicherinhalt(positionszahler_speicher)
Incr Positionszahler_speicher
Datum_monat = Speicherinhalt(positionszahler_speicher)
Incr Positionszahler_speicher
Datum_jahr = Speicherinhalt(positionszahler_speicher)
Incr Positionszahler_speicher

Uhr_stunde = Speicherinhalt(positionszahler_speicher)
Incr Positionszahler_speicher
Uhr_minute = Speicherinhalt(positionszahler_speicher)
Incr Positionszahler_speicher
Uhr_sekunde = Speicherinhalt(positionszahler_speicher)
Incr Positionszahler_speicher

'Position
Call Single_lesen(positionszahler_speicher)
Position_nord = Single_wert
Call Single_lesen(positionszahler_speicher)
Position_ost = Single_wert
Call Single_lesen(positionszahler_speicher)
Position_hoehe = Single_wert

'Dateidimensionen
Call Long_lesen(positionszahler_speicher)
Dateianfang_sektor = Long_wert
Call Long_lesen(positionszahler_speicher)
Dateiende_sektor = Long_wert
Call Long_lesen(positionszahler_speicher)
Dateiende_segment = Long_wert

End Sub

Sub Toc_darstellen(toc_nummer As Long)
Call Toc_auslesen(toc_nummer)
Print #1 , " Teil-TOC "
Print #1 , "----------"
Print #1 , "Element " ; Toc_nummer
Print #1 , "Ordner: " ; Ordnername
Print #1 , "Dateiname: " ; Dateiname
Print #1 , "Datum: " ; Datum_tag;
Print #1 , "/" ; Datum_monat;
Print #1 , "/" ; Datum_jahr
Print #1 , "Zeit: " ; Uhr_stunde;
Print #1 , ":" ; Uhr_minute;
Print #1 , ":" ; Uhr_sekunde
Print #1 , "Position Nord: " ; Position_nord;
Print #1 , " Deg"
Print #1 , "Position Ost: " ; Position_ost;
Print #1 , " Deg"
Print #1 , "Hoehe: " ; Position_hoehe;
Print #1 , " m"
Print #1 , "Dateianfang: " ; Dateianfang_sektor
Print #1 , "Dateiende: " ; Dateiende_sektor
Print #1 , "Dateiende im Segment: " ; Dateiende_segment
Print #1 , ""
Print #1 , "----------"

End Sub

Sub Aufnahme_machen()
Bildprozedur = 1
 'Kamera aus Sleepmode wecken
Rts = 1
Led = 1
Cts = 1
'Abwarten von AT&F
Call Kameraein()
Print "OK"
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If

'ATE0
Call Kameraein()
Print "OK"
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If


'Abwarten AT+CMEE=1
Call Kameraein()
Print "OK"
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If



'Abwarten AT^SACD=1
Call Kameraein()
Print "OK"
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If



'AT^SACD=2,"17"
Call Kameraein()
Print "OK"
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If



'AT^SACD=2,"17,00,2,IQP5 01.05"
Call Kameraein()
Print "OK"
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If



'AT^SACD=2,"17,04,2,3"
Call Kameraein()
Print "OK"
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If


If Kompress_qualitaet = 1 Then
'Hoehe Qualitaet
Print "^SACD: 17,06,2,1"
End If

If Kompress_qualitaet = 2 Then
'Mittlere Qualitaet
Print "^SACD: 17,06,2,2"
End If

If Kompress_qualitaet = 3 Then
'Geringe Qualitaet
Print "^SACD: 17,06,2,3"
End If


Call Kameraein()
Print "OK"
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If

Waitms 500

If Blitzlicht = 0 Then
Print "^SACD: 17,04,2,1"
End If

If Blitzlicht = 1 Then
Print "^SACD: 17,03,2"
Call Kameraein()
Print "OK"
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If
Call Kameraein()
Print "OK"
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If
Call Kameraein()
Print "OK"
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If
Waitms 500
Print "^SACD: 17,04,2,2"
End If


'AT^SACD=2,"17,04,OK"
Call Kameraein()
Print "OK"
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If


'AT^SACD=2,"17,04,2,1"
Call Kameraein()
Print "OK"
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If


'AT^SACD=2,"17,04,2,2,3057,34050"
Call Kameraein()
Print "OK"
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If

Waitms 2000

If Grosses_bild = 0 Then
Print "^SACD: 17,01,2,1"
End If

If Grosses_bild = 1 Then
Print "^SACD: 17,01,2,2"
End If


'AT^SACD=2,"17,01,OK"

Call Kameraein()
If Nur_datenausgeben = 0 Then
Print #1 , Kameratext
End If
Print "OK"

If Nur_datenausgeben = 0 Then
Print #1 , "Wechsele die Datenrate ..."
End If
Waitms 1000
Print "OK"

Baud = 115200

Waitms 2000

'AT^SADT=1,115200
Print "CONNECT"

Waitms 2000
Print "CONNECT"


If Nur_datenausgeben = 0 Then
Print #1 , "Beginne mit Datenausgabe ..."
End If

Abbruch = 0
Datenfreigabe = 0

If Eepromspeicherung = 0 Then
Print #1 , "Beginne mit Datenausgabe (D)..."
Print #1 , "CAM_B"
Waitms 50
End If

Sektornummer = 1
Call Sd_karte_lesen(sektornummer)
Call Master_toc_auslesen()
Toc_nummer = Anzahl_eintraege
Call Toc_auslesen(toc_nummer)
Ordnername = "BILDER"
Dateiname = "BILD"
Datum_tag = 16
Datum_monat = 10
Datum_jahr = 10
Uhr_stunde = Uhr_stunde_master
Uhr_minute = Uhr_minute_master
Uhr_sekunde = Uhr_sekunde_master
Position_nord = 9.999
Position_ost = 9.999
Position_hoehe = 648
Dateianfang_sektor = Dateiende_sektor + 1
Dateiende_sektor = Dateianfang_sektor

Im_sektorzaehler = 1
While Abbruch < 200000

Eingabechar2 = Ischarwaiting()
While Eingabechar2 = 1
Eingabechar2 = Ischarwaiting()

If Eingabechar2 = 1 Then
Cts = 1

If Im_sektorzaehler <= 512 Then
Eingabechar = Waitkey()
End If

If Eingabechar = 255 Then
Datenfreigabe = 1

End If

If Datenfreigabe = 1 Then
Dat = Eingabechar


If Im_sektorzaehler <= 512 Then
Speicherinhalt(im_sektorzaehler) = Dat
If Eepromspeicherung = 0 Then
If Ausgabeformat = 1 Then
Print #1 , Chr(dat);
End If

If Ausgabeformat = 2 Then
Print #1 , Hex(dat);
Print #1 , " ";
End If
End If
'Waitms 10

Incr Im_sektorzaehler
Else

Call Sd_karte_schreiben(dateiende_sektor)
Im_sektorzaehler = 1
Incr Dateiende_sektor

End If

End If

Abbruch = 0
End If
Wend


Cts = 0
Toggle Led
Incr Abbruch
Wend


Call Sd_karte_schreiben(dateiende_sektor)
Dateiende_segment = Im_sektorzaehler
Call Gps_auslesen()
Uhr_stunde = Uhr_stunde_master
Uhr_minute = Uhr_minute_master
Uhr_sekunde = Uhr_sekunde_master
Position_nord = Nordkoordinate
Position_ost = Ostkoordinate
Position_hoehe = Hoehe
Call Toc_eintrag_hinzufuegen()


If Eepromspeicherung = 0 Then
Print #1 , "CAM_E"
End If

Cts = 1
If Nur_datenausgeben = 0 Then
Print #1 , "Daten wurden uebertragen TOC-Nr." ; Toc_nummer
End If

Led = 0
If Nur_datenausgeben = 0 Then
Print #1 , "Kamera wird abgestellt"
End If
Rts = 0
If Nur_datenausgeben = 0 Then
Print #1 , "Aufnahmemodus beendet"
End If
Bildprozedur = 0
Timerzaehler = 0
End Sub

Sub Displayanzeige()
Timerzaehler = 0
Print #1 , "AT"
Wait 2
Msglen = Len(msg)

'Wie viele Hex-Pakete werden gesendet (ohne ESC)?
Hexanzahl = Msglen + 14
'Print "ATE0"

Print #1 , "AT^SSTK=" ; Hexanzahl;
'0 da single command
Print #1 , ",0"

Waitms 100
'Intialisierungssequenz
Msg_02 = "D0"
Hexanzahl = Hexanzahl - 2
T3 = Hex(hexanzahl)

Msg_02 = Msg_02 + T3
Msg_02 = Msg_02 + "8103012180820281028D"

'Ab hier Erstellen der Textnachricht
I1 = 1

Zwischenergebnis = Hex(msglen)
Msg_02 = Msg_02 + Zwischenergebnis

T1_d = "04"
Msg_02 = Msg_02 + T1_d

While I1 <= Msglen
T1_d = Mid(msg , I1 , 1)
Zwischenwert_b = T1_d
T2 = Hex(zwischenwert_b)
Msg_02 = Msg_02 + T2

Incr I1

Wend

Print #1 , Msg_02;
Print #1 , Chr(26);
End Sub


Sub Guthaben_aufladen()
If Netzanbieter = 1 Then
'Nummer der Aufladezentrale
Telefonnummer = "1155"
'Das ist die Aufladenummer
'Zwischenspeicher1 = "4410519540138068"
'Menpunkt
Zwischenspeicher2 = "4"
'Der folgende Ablauf gilt ausschlielich fr Aufladungen, die mit Aldikarten ausgefhrt werden
Print #1 , "at"
Waitms 500
Print #1 , "atd ";
Print #1 , Telefonnummer;
Print #1 , ";"
'Mglicherweise eine Werbeeinblendung - ansonsten Repeatmodus
Wait 50
Print #1 , "at +vts=";
Print #1 , Chr(34);
Print #1 , Zwischenspeicher2;
Print #1 , Chr(34)
'Warten bis Menbeschreibung zur Eingabe der Aufladenummer vorbei ist
Wait 30
Print #1 , "at"
Waitms 1000
Print #1 , "at +vts=";
Print #1 , Chr(34);
Print #1 , Zwischenspeicher1;
Print #1 , Chr(34)
'Man hrt sich die Nummer erneut an
Wait 45
Zwischenspeicher2 = "1"
Print #1 , "at +vts=";
Print #1 , Chr(34);
Print #1 , Zwischenspeicher2;
Print #1 , Chr(34)
Wait 10
Print #1 , "at"
Waitms 1000
Print #1 , "at hn";
Waitms 2000
Else
Print #1 , "Guthabenaufladeprozedur durch den Client ist nur unter Verwendung von ALDI-Talk <ALDI> aufrufbar."
End If
End Sub

Sub Datenverbindung_aufbauen()
Print #1 , "AT"
Waitms 500
Print #1 , "atd ";
Print #1 , Telefonnummer
Wait 30
End Sub

Sub Sprachverbindung_aufbauen()
Print #1 , "AT"
Waitms 500
Print #1 , "atd ";
Print #1 , Telefonnummer;
Print #1 , ";"
Wait 30
End Sub

Sub Wortsucher()
Print #1 , "AT"
Ringwortzahler = 1
Wortenthalten = 0
'Einlesen
While Wortenthalten = 0
Eingabechar = 0
Ringwort = ""

Eingabechar = 0
While Eingabechar < 13 Or Eingabechar > 13
Eingabechar = Inkey(#2)
If Eingabechar > 1 Then
If Eingabechar > 30 Then
Ringwort = Ringwort + Chr(eingabechar)
End If
End If

If Eingabechar = 13 Then
If Ringwort = "" Then
Eingabechar = 0
End If
End If
Wend

Print #4 , Ringwort

If Ringwort = "HELP" Or Ringwort = "HILFE" Then
Timerzaehler = 0
Print #1 , "Befehlsuebersicht"
Print #1 , "***TEL****"
Print #1 , "CONSMS"
Print #1 , "CONLAD"
Print #1 , "GUTCHK"
Print #1 , "RUECKD"
Print #1 , "RUECKS"
Print #1 , "ALDI"
Print #1 , "TCHIBO"
Print #1 , "***FOTO***"
Print #1 , "BILD"
Print #1 , "DAUER"
Print #1 , "BILDE"
Print #1 , "BILDA"
Print #1 , "CONRL"
Print #1 , "CONRH"
Print #1 , "CONQ1"
Print #1 , "CONQ2"
Print #1 , "CONQ3"
Print #1 , "CONSD"
Print #1 , "CONSI"
Print #1 , "CONBE"
Print #1 , "CONBA"
Print #1 , "CONDH"
Print #1 , "CONDB"
Print #1 , "****SD****"
Print #1 , "MTOC"
Print #1 , "TOC"
Print #1 , "CLEAR"
Print #1 , "MREPAIR"
Print #1 , "DUMMY"
Print #1 , "**SYSTEM**"
Print #1 , "BTEST"
Print #1 , "GPS"
Print #1 , "TEXT"
Print #1 , "ZEIT/ TIME"
Print #1 , "SETZEIT/ SETTIME"
Print #1 , "DELS0"
Print #1 , "CONCE"
Print #1 , "CONCA"
Print #1 , "SETBR1"
Print #1 , "SETBR2"

End If

If Ringwort = "CONNECT 9600/RLP" Then
Print #1 , ""
Print #1 , "Verbindung etabliert."
Wortenthalten = 1
Timerzaehler = 0
End If

If Ringwort = "RING" Then
Print #1 , "ATA"
Wortenthalten = 1
Timerzaehler = 0
End If


If Ringwort = "SETBR1" Then
Timerzaehler = 0
Print #1 , "Unterbrechungsdauer in Millisekunden eingeben (1-4000; Default=2000):"
Call Eing_v_uart()
Uebertragungsunterbrechungszeit = Val(zwischenspeicher1)

If Uebertragungsunterbrechungszeit < 1 Then
Uebertragungsunterbrechungszeit = 1
End If

If Uebertragungsunterbrechungszeit > 4000 Then
Uebertragungsunterbrechungszeit = 4000
End If


Print #1 , ""
Print #1 , "Unterbrechungszeit auf ";
Print #1 , Uebertragungsunterbrechungszeit;
Print #1 , " ms gesetzt."
End If



If Ringwort = "SETBR2" Then
Timerzaehler = 0
Print #1 , "Unterbrechungszyklus in Paketen eingeben (1-127; Default=10):"
Call Eing_v_uart()

Pausensektorvorgabe = Val(zwischenspeicher1)
If Pausensektorvorgabe < 1 Then
Pausensektorvorgabe = 1
End If

If Pausensektorvorgabe > 127 Then
Pausensektorvorgabe = 127
End If

Print #1 , ""
Print #1 , "Unterbrechungszyklus auf ";
Print #1 , pausensektorvorgabe;
Print #1 , " Pakete gesetzt."
End If



If Ringwort = "SETZEIT" Or Ringwort = "SETTIME" Then
Timerzaehler = 0
Print #1 , "Systemzeit aendern"
Print #1 , "Stunde eingeben (24h-Format):"

Call Eing_v_uart()
Uhr_stunde_master = Val(zwischenspeicher1)
Print #1 , ""
Print #1 , "Minute eingeben"

Call Eing_v_uart()
Uhr_minute_master = Val(zwischenspeicher1)
Print #1 , ""
Print #1 , "Sekunde eingeben"

Call Eing_v_uart()
Uhr_sekunde_master = Val(zwischenspeicher1)
Print #1 , ""
Print #1 , "Systemzeit geaendert"

End If


If Ringwort = "ZEIT" Or Ringwort = "TIME" Then
Timerzaehler = 0
Print #1 , "Zeit: " ; Uhr_stunde_master;
Print #1 , ":" ; Uhr_minute_master;
Print #1 , ":" ; Uhr_sekunde_master
End If


If Ringwort = "DELS0" Then
Timerzaehler = 0
Print #1 , "Sektor 0 wird geloescht."
Sektornummer = 0
Spezialzaehler = 0
While Spezialzaehler < 512
Speicherinhalt(zahler) = 0
Incr Spezialzaehler
Wend
Call Sd_karte_schreiben(sektornummer)
Print #1 , "Sektor 0 wurde geloescht."
End If


If Ringwort = "BILD" Then
Timerzaehler = 0
Print #1 , "Bildmodus wird geladen"
Led = 0
Wortenthalten = 1
'Setzen der Steuerleitungen fr die Kamera
Cts = 0
Rts = 0
Led = 0
Baud = 19200
Clear Serialin
Call Aufnahme_machen()
End If

If Ringwort = "CONSMS" Or Ringwort = "CONLAD" Or Ringwort = "RUECKD" Or Ringwort = "RUECKS" Then
Timerzaehler = 0
Print #1 , "Eingabe?: ";

Call Eing_v_uart()

Print #1 , ""
Print #1 , "Die Eingabe lautet:";
Telefonnummer = Zwischenspeicher1
Print #1 , Zwischenspeicher1


If Ringwort = "CONLAD" And Netzanbieter = 2 Then
nop
Else

Print #1 , "Beende die Datenverbindung ..."

Wait 3
Waitms 500
Print #1 , Chr(43);
Print #1 , Chr(43);
Print #1 , Chr(43);
Wait 2
Print #1 , "AT"
Wait 2
Print #1 , "at hn"
Wait 1
Print #1 , "at hn"
Wait 4

End If

If Ringwort = "CONLAD" Then
Timerzaehler = 0
Call Guthaben_aufladen()
Print #1 , "AT"
Wait 2
End If

If Ringwort = "RUECKD" Then
Timerzaehler = 0
Call Datenverbindung_aufbauen()
End If

If Ringwort = "RUECKS" Then
Timerzaehler = 0
Call Sprachverbindung_aufbauen()
End If

If Ringwort = "CONSMS" Then
Timerzaehler = 0
'Guthaben abfragen

If Netzanbieter = 1 Then
Print #1 , "atd*100#;"
End If

If Netzanbieter = 2 Then
Print #1 , "atd*101#;"
End If

Msg = ""
Eingabechar = 0
Abbruch = 0

Spezialzaehler = 1
If Netzanbieter = 2 Then
Spezialzaehler = 3
End If
'Es wird auf das "o" in Euro getriggert
While Eingabechar < 111 Or Eingabechar > 111
Eingabechar = Inkey(#2)
If Eingabechar > 1 Then
If Eingabechar > 30 Then
Msg = Msg + Chr(eingabechar)
If Eingabechar = 111 Then
Decr Spezialzaehler
If Spezialzaehler = 0 Then
Else
Eingabechar = 0
End If
End If
End If
End If

Incr Abbruch
If Abbruch > 2000000 Then
Eingabechar = 111
End If
Wend

Led = 1
If Abbruch < 2000000 Then
Guthaben = Msg
Laenge = Len(telefonnummer)
If Laenge > 2 Then
Call Sms_senden()
End If

Msg = "SMS versendet"
Call Displayanzeige()
Waitms 2000
Else
Msg = "SMS nicht versendet"
Call Displayanzeige()
Waitms 2000
End If
Led = 0
End If

Wortenthalten = 1
End If

If Ringwort = "BILDE" Then
Timerzaehler = 0
Bildprozedur = 1
Sektornummer = 1
Call Sd_karte_lesen(sektornummer)
Call Master_toc_auslesen()
Print #1 , "Welches Bild soll ausgegeben werden?";
Print #1 , " - max. " ; Anzahl_eintraege
Call Eing_v_uart()
Print #1 , ""
Print #1 , "Die Eingabe lautet:";
Print #1 , Zwischenspeicher1
Sektornummer = 1
Call Sd_karte_lesen(sektornummer)
Call Master_toc_auslesen()
Toc_nummer = Val(zwischenspeicher1)
If Anzahl_eintraege >= Toc_nummer Then
Call Bildausgabe()
Else
Print #1 , "SD-Karte soll nicht quer gelesen werden ..."
End If
Bildprozedur = 0
Timerzaehler = 0
End If

If Ringwort = "BILDA" Then
Timerzaehler = 0
Bildprozedur = 1
Sektornummer = 1
Call Sd_karte_lesen(sektornummer)
Call Master_toc_auslesen()
Print #1 , "Achtung: Alle Bilddateien werden ausgegeben!"
Print #1 , "Fortfahren? Ja=1/Nein=0"
Call Eing_v_uart()
Print #1 , ""
Print #1 , "Die Eingabe lautet:";
Print #1 , Zwischenspeicher1
Sektornummer = 1
Call Sd_karte_lesen(sektornummer)
Call Master_toc_auslesen()
Toc_nummer = 1
If Zwischenspeicher1 = "1" Then
While Anzahl_eintraege >= Toc_nummer
Print #1 , "TOC-Nr. " ; Toc_nummer;
Print #1 , " von " ; Anzahl_eintraege
Call Bildausgabe()
Incr Toc_nummer
Waitms 500
Wend
Else
Print #1 , "Ausgabe wurde abgebrochen."
End If
Bildprozedur = 0
Timerzaehler = 0
End If

If Ringwort = "CLEAR" Then
Timerzaehler = 0
Print #1 , "Achtung: In 5 Sekunden wird die Zuordnungstabelle geloescht ..."
Waitms 5000
'Anfang Anlegen der Master-TOC
Call Master_toc_anlegen()
'Ende Anlegen der Master-TOC
Ordnername = "INIT"
Dateiname = "Initialisierung"
Datum_tag = 07
Datum_monat = 3
Datum_jahr = 10
Uhr_stunde = Uhr_stunde_master
Uhr_minute = Uhr_minute_master
Uhr_sekunde = Uhr_sekunde_master
Position_nord = 9.9999
Position_ost = 9.9999
Position_hoehe = 999
Dateianfang_sektor = 10000
Dateiende_sektor = 10001
Dateiende_segment = 99
Call Toc_eintrag_hinzufuegen()
Sektornummer = 1
Call Sd_karte_lesen(sektornummer)
Call Master_toc_darstellen()
End If

If Ringwort = "MTOC" Then
Timerzaehler = 0
Sektornummer = 1
Call Sd_karte_lesen(sektornummer)
Call Master_toc_darstellen()
End If

If Ringwort = "BTEST" Then
Timerzaehler = 0
Sektornummer = 1
Sektorzaehler = 0
While Sektorzaehler <= 255
Print #1 , Chr(sektorzaehler);
Incr Sektorzaehler
Wend
End If

If Ringwort = "MREPAIR" Then
Timerzaehler = 0
Sektornummer = 1
Call Sd_karte_lesen(sektornummer)
Print #1 , "Jetztiger Zustand:"
Call Master_toc_darstellen()
Print #1 , "MASTER-TOC reparieren?"
Print #1 , "Fortfahren? Ja=1/Nein=0"
Call Eing_v_uart()
Print #1 , Zwischenspeicher1
If Zwischenspeicher1 = "1" Then
Print #1 , "Anzahl Eintraege?"
Call Eing_v_uart()
Print #1 , Zwischenspeicher1
Anzahl_eintraege = Val(zwischenspeicher1)
Datentraegerbezeichnung = "!!!Repariert!!!"
Datentraegergroesse = 1953125000
Belegter_speicher = 0
Anzahl_ordner = 0
Beginn_der_toc = 2
Ende_der_toc = 9999
Call Speicherinhalt_leeren()
Call Master_toc_bearbeiten()
Sektornummer = 1
Call Sd_karte_schreiben(sektornummer)
Call Speicherinhalt_leeren()
Else
Print #1 , "Reperatur abgebrochen."
End If
End If


If Ringwort = "TOC" Then
Timerzaehler = 0
Print #1 , "TOC-Darstellung..."
Sektornummer = 1
Call Sd_karte_lesen(sektornummer)
Call Master_toc_auslesen()
Toc_nummer = 1
While Toc_nummer <= Anzahl_eintraege
Call Toc_darstellen(toc_nummer)
Incr Toc_nummer
Wend
End If

If Ringwort = "DUMMY" Then
Timerzaehler = 0
Sektornummer = 1
Call Sd_karte_lesen(sektornummer)
Call Master_toc_auslesen()
Toc_nummer = Anzahl_eintraege
Call Toc_auslesen(toc_nummer)
Print #1 , "TOC-NR: " ; Toc_nummer
Ordnername = "INIT"
Dateiname = "Initialisierung"
Datum_tag = Toc_nummer
Datum_monat = Toc_nummer
Datum_jahr = Toc_nummer
Uhr_stunde = Toc_nummer
Uhr_minute = Toc_nummer
Uhr_sekunde = Toc_nummer
Position_nord = 9.9999
Position_ost = 9.9999
Position_hoehe = 999
Print #1 , "Dateiende_sektor: " ; Dateiende_sektor
Dateianfang_sektor = Dateiende_sektor + 1
Dateiende_sektor = Dateianfang_sektor
Dateiende_segment = 99
Call Toc_eintrag_hinzufuegen()
End If

If Ringwort = "ALDI" Then
Timerzaehler = 0
Netzanbieter = 1
Print #1 , "Netzanbieter wurde auf ALDI (eplus) gesetzt."
End If

If Ringwort = "TCHIBO" Then
Timerzaehler = 0
Netzanbieter = 2
Print #1 , "Netzanbieter wurde auf Tchibo (o2) gesetzt."
End If

If Ringwort = "GPS" Then
Timerzaehler = 0
Call Gps_auslesen()
End If

If Ringwort = "TEXT" Then
Timerzaehler = 0
Print #1 , "Achtung: Datenverbindung wird beendet! (1=fortfahren, 0=Abbrechen)"
Call Eing_v_uart()
Textausgabewert = Val(zwischenspeicher1)

If Textausgabewert = 1 Then
Msg = "CSD-Meldung:" + Chr(13)
Print #1 , "Textausgabe."

Print #1 , "Zeile 1:"
Call Eing_v_uart()
Print #1 , "Zeile 1:";
Print #1 , Zwischenspeicher1
Msg = Msg + Zwischenspeicher1
Msg = Msg + Chr(13)

Print #1 , "Zeile 2:"
Call Eing_v_uart()
Print #1 , "Zeile 2:";
Print #1 , Zwischenspeicher1
Msg = Msg + Zwischenspeicher1
Msg = Msg + Chr(13)

Print #1 , "Zeile 3:"
Call Eing_v_uart()
Print #1 , "Zeile 3:";
Print #1 , Zwischenspeicher1
Msg = Msg + Zwischenspeicher1
Msg = Msg + Chr(13)

Print #1 , "Zeile 4:"
Call Eing_v_uart()
Print #1 , "Zeile 4:";
Print #1 , Zwischenspeicher1
Msg = Msg + Zwischenspeicher1
Msg = Msg + " "


Print #1 , "Beende die Datenverbindung."
Wait 3
Waitms 500
Print #1 , Chr(43);
Print #1 , Chr(43);
Print #1 , Chr(43);
Wait 2
Print #1 , "AT"
Wait 2

Print #1 , "at hn"
Wait 1
Print #1 , "at hn"
Wait 4

Call Displayanzeige()
Waitms 15000
Print #1 , "AT"
Else
Print #1 , "Textausgabe wurde abbgebrochen."
End If
End If

If Ringwort = "GUTCHK" Then
Timerzaehler = 0
Msg = Guthaben
Print #1 , "Guthaben ..."
Print #1 , Msg
End If


If Ringwort = "DAUER" Then
Timerzaehler = 0
Sektornummer = 1
Call Sd_karte_lesen(sektornummer)
Call Master_toc_auslesen()
Print #1 , "Dauerbildaufnahme"
Print #1 , "Wie viele Bilder? (max. 40)"
Call Eing_v_uart()
Print #1 , ""
Print #1 , "Die Eingabe lautet:";
Print #1 , Zwischenspeicher1
Dauerbildaufnahme_wert = Val(zwischenspeicher1)
Dauerbildaufnahme_zahler = 1
If Dauerbildaufnahme_wert <= 40 Then
While Dauerbildaufnahme_zahler <= Dauerbildaufnahme_wert
Print #1 , "Bildnummer: " ; Dauerbildaufnahme_zahler;
Print #1 , " von " ; Dauerbildaufnahme_wert
Print #1 , "Bildmodus wird geladen"
Led = 0
Wortenthalten = 1
'Setzen der Steuerleitungen fr die Kamera
Cts = 0
Rts = 0
Led = 0
Baud = 19200
Clear Serialin
Wait 3
Call Aufnahme_machen()
Incr Dauerbildaufnahme_zahler
Wend
Else
Print #1 , "Zu viele Bilder!"
End If

End If


'If Ringwort = "BAUD48" Then
'Timerzaehler = 0
'Print #1 , "Baudrate wird auf 4800 bps gesetzt"
'Baud #1 , 4800
'Baud #2 , 4800
'End If

'If Ringwort = "BAUD96" Then
'Timerzaehler = 0
'Print #1 , "Baudrate wird auf 9600 bps gesetzt"
'Baud #1 , 9600
'Baud #2 , 9600
'End If

'If Ringwort = "BAUD576" Then
'Timerzaehler = 0
'Print #1 , "Baudrate wird auf 57600 bps gesetzt"
'Baud #1 , 57600
'Baud #2 , 57600
'End If

If Ringwort = "CONRL" Then
Timerzaehler = 0
Print #1 , "Geringe Aufloesung gesetzt"
Grosses_bild = 0
Wortenthalten = 1
End If

If Ringwort = "CONRH" Then
Timerzaehler = 0
Print #1 , "Hohe Aufloesung gesetzt"
Grosses_bild = 1
Wortenthalten = 1
End If


If Ringwort = "CONQ3" Then
Timerzaehler = 0
Print #1 , "Hohe Komprimierung/ geringe Qualitaet gesetzt"
Kompress_qualitaet = 3
Wortenthalten = 1
End If

If Ringwort = "CONQ2" Then
Timerzaehler = 0
Print #1 , "Mittlere Komprimierung/ mittlere Qualitaet gesetzt"
Kompress_qualitaet = 2
Wortenthalten = 1
End If

If Ringwort = "CONQ1" Then
Timerzaehler = 0
Print #1 , "Geringe Komprimierung/ hohe Qualitaet gesetzt"
Kompress_qualitaet = 1
Wortenthalten = 1
End If

If Ringwort = "CONSD" Then
Timerzaehler = 0
Print #1 , "Daten werden direkt uebertragen"
Eepromspeicherung = 0
Wortenthalten = 1
End If

If Ringwort = "CONSI" Then
Timerzaehler = 0
Print #1 , "Daten werden gepuffert"
Eepromspeicherung = 1
Wortenthalten = 1
End If

If Ringwort = "CONBE" Then
Timerzaehler = 0
Print #1 , "Blitz eingeschaltet"
Blitzlicht = 1
Wortenthalten = 1
End If

If Ringwort = "CONBA" Then
Timerzaehler = 0
Print #1 , "Blitz ausgeschaltet"
Blitzlicht = 0
Wortenthalten = 1
End If

If Ringwort = "CONDH" Then
Timerzaehler = 0
Print #1 , "HEX-DUMP verwendet"
Ausgabeformat = 2
Wortenthalten = 1
End If

If Ringwort = "CONDB" Then
Timerzaehler = 0
Print #1 , "Binaerdatenausgabe"
Ausgabeformat = 1
Wortenthalten = 1
End If

If Ringwort = "CONCE" Then
Timerzaehler = 0
Print #1 , "Zusaetliche Kommentare ein"
Nur_datenausgeben = 0
Wortenthalten = 1
End If

If Ringwort = "CONCA" Then
Timerzaehler = 0
Print #1 , "Zusaetliche Kommentare aus"
Nur_datenausgeben = 1
Wortenthalten = 1
End If

Wend

End Sub

Sub Sms_senden()
Timerzaehler = 0
Dim J1 As Integer
Dim Ke As Byte
Dim Md As Byte
Dim Groesse_der_sms As Integer
Dim Smssenden_fehler As Bit
Dim Smssenden_fehler_reak As Bit
Smsversuchszahler = 0
'Intialisierungssequenz ohne SMSC
Msg_02 = "001100"

'Hinzufgen der Lngeninformation der Nummer
Zwischenwert_b = Len(telefonnummer)
Msglen = Zwischenwert_b
Zwischenergebnis = Hex(zwischenwert_b)
Msg_02 = Msg_02 + Zwischenergebnis

'Hinzufgen der 91
Msg_02 = Msg_02 + "91"

'Berechnung der Telefonnummer
I1 = 1
J1 = 2
T1 = ""
T2 = ""

While I1 <= Msglen

T1 = Mid(telefonnummer , I1 , 1 )
T2 = Mid(telefonnummer , J1 , 1 )

If I1 = Msglen Then
'Abfragen, ob die Laenge der Telefonnummer gerade ist -> Ansonsten zum Fllen ein F am Ende einsetzen
If Msglen = 2 Or Msglen = 4 Or Msglen = 6 Or Msglen = 8 Or Msglen = 10 Or Msglen = 12 Or Msglen = 14 Then
T2 = Mid(telefonnummer , J1 , 1 )
Else
T2 = "F"
End If
End If

Msg_02 = Msg_02 + T2
Msg_02 = Msg_02 + T1
T1 = ""
T2 = ""
Incr I1
Incr I1
Incr J1
Incr J1
Wend

'Weitere statische Sequenz
Msg_02 = Msg_02 + "0000AA"

I1 = 1
J1 = 2
Zwischenwert_b = Len(msg)
Msglen = Zwischenwert_b
Zwischenergebnis = Hex(zwischenwert_b)
Msg_02 = Msg_02 + Zwischenergebnis

Groesse_der_sms = Len(msg_02)
While I1 <= Msglen
T1 = Mid(msg , I1 , 1 )
K1 = Asc(t1)
T2 = Mid(msg , J1 , 1 )
K2 = Asc(t2)
Md = I1 - 1
Ke = Md Mod 8
Shift K1 , Right , Ke
Ke = 7 - Ke
Shift K2 , Left , Ke
K1 = K1 + K2
Zwischenergebnis = Hex(k1)
Msg_02 = Msg_02 + Zwischenergebnis
Incr Groesse_der_sms
Incr Groesse_der_sms
Incr I1
Incr J1
If Ke = 1 Then
Incr J1
Incr I1
End If
Wend

Msglen = Groesse_der_sms
Zwischenwert_s = Msglen / 2
Zwischenwert_b = Round(zwischenwert_s)
Msglen = Zwischenwert_b - 1
Smssenden_fehler = 1
Smssenden_fehler_reak = 0

While Smssenden_fehler = 1
Print #1 , "AT"
Wait 2
Print #1 , "AT+CMGS=" ; Msglen

Waitms 5
If Smssenden_fehler_reak = 0 Then
Eingabechar = 0
While Eingabechar < 13 Or Eingabechar > 13
Eingabechar = Inkey(#2)
Wend
End If
Waitms 50
Print #1 , Msg_02;
Print #1 , Chr(26);

Msg = ""
Zwischenwert_b = 0
While Zwischenwert_b < 10 Or Zwischenwert_b > 10
Zwischenwert_b = Inkey(#2)
Msg = Msg + Chr(zwischenwert_b)
Wend

Msg = ""
Zwischenwert_b = 0
While Zwischenwert_b < 10 Or Zwischenwert_b > 10
Zwischenwert_b = Inkey(#2)
Msg = Msg + Chr(zwischenwert_b)
Wend

T2 = Mid(msg , 1 , 2)

If T2 = "+C" Then
Smssenden_fehler = 0
Else
Print #1 , "Fehler beim Versenden. Retry."
Smssenden_fehler = 1
Smssenden_fehler_reak = 0
End If

Wait 5

Led = 0
Waitms 500
Led = 1
Waitms 500
Led = 0
Waitms 500
Led = 1

Incr Smsversuchszahler
If Smsversuchszahler > 20 Then
Smssenden_fehler = 0
End If
Wend
End Sub

Sub Kameraein()
Kameratext = ""
Eingabechar = 0
Abbruch = 0

While Eingabechar < 13 Or Eingabechar > 13
Eingabechar = Inkey()
If Eingabechar > 13 Then
Kameratext = Kameratext + Chr(eingabechar)
End If
Incr Abbruch
If Abbruch > 3000000 Then
Eingabechar = 13
End If
Wend

End Sub

Sub Mobilein()
Bildprozedur = 1
Porta.2 = 1
Waitms 200
If Cmd2 = 0 Then
Ringwort = ""
'Einlesen
Timeoutzahler = 0
Eingabechar = 0
Print #1 , "AT"
Waitms 500
Print #1 , "AT"
While Eingabechar < 13 Or Eingabechar > 13
Eingabechar = Inkey(#2)
If Eingabechar > 1 Then
Ringwort = Ringwort + Chr(eingabechar)
Timeoutzahler = 0
End If
Incr Timeoutzahler

If Timeoutzahler = 300 Then
Print #1 , "AT"
End If

If Timeoutzahler = 700 Then
Print #1 , "AT"
End If

If Timeoutzahler > 2000 Then
Eingabechar = 13
End If
Wend

Mobil_ist_aktiv = 0

If Timeoutzahler < 2000 Then
Mobil_ist_aktiv = 1
End If

If Ringwort <> "" Then
Mobil_ist_aktiv = 1
End If

If Mobil_ist_aktiv = 1 Then
nop
Else

Print #4 , "Selbsttest - Mobiltelefon inaktiv"
Print #1 , "Zwangstrennung - es wurde keine Eingabe festgestellt."
Waitms 500
Mob_ein = 0
Wait 4
Mob_ein = 1
Wait 2
Mob_opto = 1
Wait 1
Mob_opto = 0
Wait 1
Mob_opto = 1
Wait 1
Mob_opto = 0
Wait 1

Mob_ein = 0
Waitms 500
Mob_ein = 1
Waitms 500

Mob_ein = 0
Waitms 500
Mob_ein = 1
Waitms 500

Mob_ein = 0
Waitms 500
Mob_ein = 1
Waitms 500

Print #1 , "AT"
Waitms 500
Print #1 , "AT"
End If

End If
Bildprozedur = 0
Timerzaehler = 0
End Sub




Sub Eing_v_uart()
Zwischenspeicher1 = ""
Eingabechar = 0
Abbruch = 0

While Eingabechar < 13 Or Eingabechar > 13
Eingabechar = Inkey(#2)
If Eingabechar > 1 Then
If Eingabechar > 1 Then

If Eingabechar < 13 Or Eingabechar > 13 Then
Print #1 , Chr(eingabechar) ;
Zwischenspeicher1 = Zwischenspeicher1 + Chr(eingabechar)
End If

Abbruch = 0
End If
End If
Incr Abbruch
If Abbruch > 2000000 Then
Eingabechar = 13
End If
Wend
End Sub


Sub Bildausgabe()
Sektornummer = 1
Call Sd_karte_lesen(sektornummer)
Call Master_toc_auslesen()
Call Toc_auslesen(toc_nummer)

If Ordnername = "BILDER" Then
Print #1 , "CAM_B"
Im_sektorzaehler_a = Dateiende_segment
Sektorzaehler_a = Dateiende_sektor
Im_sektorzaehler = 1
Sektorzaehler = Dateianfang_sektor
Pausensektorzahler = 0
While Sektorzaehler <= Sektorzaehler_a
Sektornummer = Sektorzaehler
Call Sd_karte_lesen(sektornummer)

Im_sektorzaehler = 1
While Im_sektorzaehler <= 512
If Sektorzaehler_a = Sektorzaehler Then

If Im_sektorzaehler < Im_sektorzaehler_a Then
If Ausgabeformat = 2 Then
Print #1 , Hex(speicherinhalt(im_sektorzaehler));
Print #1 , " ";
Else
Print #1 , Chr(speicherinhalt(im_sektorzaehler));
End If
End If

Else
If Ausgabeformat = 2 Then
Print #1 , Hex(speicherinhalt(im_sektorzaehler));
Print #1 , " ";
Else
Print #1 , Chr(speicherinhalt(im_sektorzaehler));
End If
End If

Incr Im_sektorzaehler
Wend

Incr Sektorzaehler
Incr Pausensektorzahler


If Pausensektorzahler = Pausensektorvorgabe Then
'Warten, damit das Telefon mitkommt die Daten zu schaufeln
Pausensektorzahler = 0
Waitms Uebertragungsunterbrechungszeit
End If


Wend
Print #1 , "CAM_E"
End If
End Sub

Sub Gps_auslesen()
'CMD5 auf High ziehen
Portb.3 = 1
Waitms 200
If Cmd5 = 0 Then

Timeout_gps = 2
Print #1 , "Im GPS-Modus mit $ verlassen - Timeout: " ; Timeout_gps
Zwischenwert_b = 0
Timeoutzahler = 0
While Zwischenwert_b < 36 Or Zwischenwert_b > 36
If Timeoutzahler < Timeout_gps Then

Msg = ""
Zwischenwert_b = 0
Wartezeit = 0
While Zwischenwert_b < 13 Or Zwischenwert_b > 13
Zwischenwert_b = Inkey(#3)
If Zwischenwert_b > 0 Then
T1 = Chr(zwischenwert_b)
Msg = Msg + T1
Wartezeit = 0
End If
Incr Wartezeit
If Wartezeit > 100000 Then
Zwischenwert_b = 13
Timeoutzahler = Timeoutzahler + 1
End If
Wend
'$GPGGA,
Zwischenspeicher1 = ""
Zwischenspeicher1 = Mid(msg , 1 , 6 )
If Zwischenspeicher1 = "$GPGGA" Then
Print #1 , Msg
Zwischenwert_b = Len(msg)
Zahler = 1
Zwischenspeicher1 = ""
T1 = ","
Komma = 0
While Zahler <= Zwischenwert_b
T2 = Mid(msg , Zahler , 1)
If T1 = T2 Then
Incr Komma

If Komma = 2 Then
'Uhrzeit
Uhrzeitstring = Mid(zwischenspeicher1 , 1 , 2 )
Uhrzeit_stunde = Val(uhrzeitstring)

Uhrzeitstring = Mid(zwischenspeicher1 , 3 , 2 )
Uhrzeit_minute = Val(uhrzeitstring)

Uhrzeitstring = Mid(zwischenspeicher1 , 5 , 2 )
Uhrzeit_sekunde = Val(uhrzeitstring)

End If


If Komma = 3 Then
'norden
Nordkoordinate = Val(zwischenspeicher1)
Nordkoordinate = Nordkoordinate / 100
End If

If Komma = 5 Then
'osten
Ostkoordinate = Val(zwischenspeicher1)
Ostkoordinate = Ostkoordinate / 100
End If

If Komma = 9 Then
'Genauigkeit
Genauigkeit = Val(zwischenspeicher1)
End If

If Komma = 10 Then
'Hoehe
Hoehe = Val(zwischenspeicher1)
End If

Zwischenspeicher1 = ""
Else
Zwischenspeicher1 = Zwischenspeicher1 + T2
End If

Incr Zahler
Wend


Nordkoordinate_i = Int(nordkoordinate)
Nordkoordinate = Nordkoordinate - Nordkoordinate_i
Nordkoordinate = Nordkoordinate * 100
Nordkoordinate = Nordkoordinate / 60
Nordkoordinate = Nordkoordinate + Nordkoordinate_i


Ostkoordinate_i = Int(ostkoordinate)
Ostkoordinate = Ostkoordinate - Ostkoordinate_i
Ostkoordinate = Ostkoordinate * 100
Ostkoordinate = Ostkoordinate / 60
Ostkoordinate = Ostkoordinate + Ostkoordinate_i

If Genauigkeit > 45 Then
Nordkoordinate = 0
Ostkoordinate = 0
Hoehe = 0
End If

Print #1 , "Nord [Deg]: " ; Nordkoordinate;
Print #1 , "/ Ost [Deg] : " ; Ostkoordinate;
Print #1 , "/ Hoehe [m] : " ; Hoehe;
Print #1 , "/ Genauigkeit [m]: " ; Genauigkeit
Print #1 , "Uhrzeit: " ; Uhrzeit_stunde;
Print #1 , ":" ; Uhrzeit_minute;
Print #1 , ":" ; Uhrzeit_sekunde


Uhr_stunde_master = Uhrzeit_stunde
Uhr_minute_master = Uhrzeit_minute
Uhr_sekunde_master = Uhrzeit_sekunde

Else
Print #1 , "Fehler: " ; Msg
End If
Zwischenwert_b = Inkey(#2)
If Zwischenwert_b > 32 And Zwischenwert_b < 127 Then
Timeoutzahler = 0
Else
Incr Timeoutzahler
End If

Else
Zwischenwert_b = 36
End If

Wend
Close #3
Else
Print #1 , "Kein GPS-Modul angeschlossen."
End If
End Sub

Tim0_isr:
If Timerzaehler_uhr > 41 Then
Stop Timer0
If Uhr_sekunde_master < 59 Then
Uhr_sekunde_master = Uhr_sekunde_master + 1
Else
Uhr_sekunde_master = 0
If Uhr_minute_master < 59 Then
Uhr_minute_master = Uhr_minute_master + 1
Else
Uhr_minute_master = 0
If Uhr_stunde_master < 23 Then
Uhr_stunde_master = Uhr_stunde_master + 1
Else
Uhr_stunde_master = 0
End If
End If
End If
Start Timer0
Timerzaehler_uhr = 0
End If


If Timerzaehler > 10000 Then
If Bildprozedur = 0 Then
Call Mobilein()
End If
Timerzaehler = 0
End If
Incr Timerzaehler
Incr Timerzaehler_uhr
Return